<div class="main-content">

	<div class="mb-16">
		<h3 fxFlex=""> Список пользователей</h3>
		<a mat-flat-button
			color="accent"
			[routerLink]="['add']"> Добавить нового пользователя </a>
	</div>

	<app-loader *ngIf="isLoad"></app-loader>

	<div class="art-card" *ngIf="persons" [@animate]="{value:'*',params:{delay:'300ms',y:'25px'}}">
		<table mat-table [dataSource]="persons" matSort
			(matSortChange)="sortEvent.next($event)"
			[matSortActive]="params.sortby"
			[matSortDirection]="params.order">
			<!-- surname -->
			<ng-container matColumnDef="surname">
				<th mat-header-cell  *matHeaderCellDef mat-sort-header="surname"> Фамилия </th>
				<td mat-cell *matCellDef="let row"> {{ row.surname }}</td>
			</ng-container>
			<ng-container matColumnDef="searchSurname">
				<th mat-header-cell *matHeaderCellDef>
					<mat-form-field appearance="standard">
						<input matInput
							[(ngModel)] = "params.search_surname"
							(input)="search.next($event.target.value)"
							placeholder="Поиск по фамилии" >
					</mat-form-field>
				</th>
			</ng-container>

			<!-- name -->
			<ng-container matColumnDef="name">
				<th mat-header-cell *matHeaderCellDef mat-sort-header="name"> Имя </th>
				<td mat-cell *matCellDef="let row"> {{ row.name }}</td>
			</ng-container>
			<ng-container matColumnDef="searchName">
				<th mat-header-cell *matHeaderCellDef>
					<mat-form-field appearance="standard">
						<input matInput placeholder="Поиск по имени"
							[(ngModel)] = "params.search_name"
							(input)="search.next($event.target.value)"
						>
					</mat-form-field>
				</th>
			</ng-container>

			<!-- patronymic -->
			<ng-container matColumnDef="patronymic">
				<th mat-header-cell *matHeaderCellDef mat-sort-header="patronymic"> Отчество </th>
				<td mat-cell *matCellDef="let row"> {{ row.patronymic }}</td>
			</ng-container>
			<ng-container matColumnDef="searchPatronymic">
				<th mat-header-cell *matHeaderCellDef>
					<mat-form-field appearance="standard">
						<input matInput placeholder="Поиск по отчеству"
							[(ngModel)] = "params.search_patronymic"
							(input)="search.next($event.target.value)"
						>
					</mat-form-field>
				</th>
			</ng-container>

			<!-- role -->
			<ng-container matColumnDef="role" >
				<th mat-header-cell *matHeaderCellDef mat-sort-header="id_role"> Роль </th>
				<td mat-cell *matCellDef="let row"> {{ row.name_role }}</td>
			</ng-container>
			<ng-container matColumnDef="searchRole">
				<th mat-header-cell *matHeaderCellDef></th>
			</ng-container>

			<!-- login -->
			<ng-container matColumnDef="login">
				<th mat-header-cell *matHeaderCellDef  mat-sort-header="login"> Логин </th>
				<td mat-cell *matCellDef="let row"> {{ row.login }}</td>
			</ng-container>
			<ng-container matColumnDef="searchLogin">
				<th mat-header-cell *matHeaderCellDef>
					<mat-form-field appearance="standard">
						<input matInput placeholder="Поиск по логину"
							[(ngModel)] = "params.search_login"
							(input)="search.next($event.target.value)"
						>
					</mat-form-field>
				</th>
			</ng-container>

			<!-- registration_date -->
			<ng-container matColumnDef="registrationDate">
				<th mat-header-cell *matHeaderCellDef  mat-sort-header="registration_date"> Дата регистрации </th>
				<td mat-cell *matCellDef="let row"> {{ row.registration_date | date: 'dd.MM.yyyy HH:mm'}}</td>
			</ng-container>
			<ng-container matColumnDef="searchRegistrationDate">
				<th mat-header-cell *matHeaderCellDef></th>
			</ng-container>

			<!-- actual -->
			<ng-container matColumnDef="actual">
				<th mat-header-cell *matHeaderCellDef  mat-sort-header="actual"> Активность </th>
				<td mat-cell *matCellDef="let row">
					<mat-slide-toggle
						[(ngModel)]="row.actual"
						(click)="$event.stopPropagation()"
						(change)="toggleUser($event, row);"
						color="primary">
					</mat-slide-toggle>
				</td>
			</ng-container>
			<ng-container matColumnDef="searchActions">
				<th mat-header-cell *matHeaderCellDef>
					<button mat-icon-button
						(click)="clearFilter($event)"
						[disabled]="! (this.params.search_name
						|| this.params.search_surname
						|| this.params.search_patronymic
						|| this.params.search_login)"
						matTooltip="Очистить фильтр"
						color="primary">
						<mat-icon svgIcon="cancel"></mat-icon>
					</button>

				</th>
			</ng-container>

			<ng-container matColumnDef="noRecord">
				<td mat-footer-cell *matFooterCellDef [colSpan]="displayedColumns.length" ><i>Пользователи не найдены</i></td>
			</ng-container>

			<!-- contents row -->
			<tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: false"></tr>
			<tr mat-header-row *matHeaderRowDef="searchColumns" class="searchColumns" ></tr>
			<tr mat-row class="table-row" *matRowDef="let row; columns: displayedColumns;" [routerLink]="['./', row.id]"> </tr>
			<tr mat-footer-row *matFooterRowDef="['noRecord']" [hidden]="persons.length > 0"></tr>

		</table>

		<mat-paginator  [length]="total"
			[pageIndex]="params.page - 1"
			[pageSize]="params.limit"
			(page)="pagination.next($event)"
			[pageSizeOptions]="pageSizeOptions"
			showFirstLastButtons>
		</mat-paginator>

	</div>



</div>


